<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?

require_once 'documento.php';

class CTPS extends Documento
{
	function setTableDefinition()
	{
		$this->setTableName('saude.ctps');
		$this->hasColumn('numero','integer', NULL, array('notnull'));
		$this->hasColumn('serie', 'integer', NULL, array('notnull'));
		$this->hasColumn('idestado', 'integer', NULL, array('notnull'));
		$this->hasColumn('data_emissao', 'date');

		$this->hasColumn('idpessoa', 'integer', NULL, array('notnull'));

		Documento::setTableDefinition();
	}

	function validate()
	{
		Documento::validate();

		$erros = array();

		if(!$this->data_emissao)
			$this->data_emissao = null;

		if(!$this->numero)
			$erros[] = 'O número da carteira de trabalho deve ser informado';

		if(!$this->numero)
			$erros[] = 'A série da carteira de trabalho deve ser informada';

		if($erros)
			throw new Exception(implode("\n",$erros));
	}

	function setUp()
	{
		Documento::setUp();

		$this->hasOne('Estado as estado',
			array('local' => 'idestado',
				  'foreign' => 'id'));

		$this->index('unique_pessoa_ctps',
			array('fields'=>array('idpessoa'),
			      'type'=>'unique'));

		$this->index('unique_ctps',
			array('fields' => array('numero', 'serie', 'idestado'),
			      'type' => 'unique'));

		$this->hasOne('Pessoa as pessoa',
			array('local'=>'idpessoa',
			      'foreign'=>'id'));
	}
};

?>
